Subject: Re: [PATCH RFC 01/18] net: phy: Add phydev->eee_active to simplify adjust link callbacks

From: Andrew Lunn <[email-masked]>
Date: Fri, 17 Feb 2023 14:37:01 +0100

On Fri, Feb 17, 2023 at 11:36:31AM +0000, Russell King (Oracle) wrote:
> On Fri, Feb 17, 2023 at 04:42:13AM +0100, Andrew Lunn wrote:
> > MAC drivers which support EEE need to know the results of the EEE
> > auto-neg in order to program the hardware to perform EEE or not.  The
> > oddly named phy_init_eee() can be used to determine this, it returns 0
> > if EEE should be used, or a negative error code,
> > e.g. -EOPPROTONOTSUPPORT if the PHY does not support EEE or negotiate
> > resulted in it not being used.
> > 
> > However, many MAC drivers get this wrong. Add phydev->eee_active which
> > indicates the result of the autoneg for EEE, including if EEE is
> > administratively disabled with ethtool. The MAC driver can then access
> > this in the same way as link speed and duplex in the adjust link
> > callback.
> > 
> > Signed-off-by: Andrew Lunn <[email-masked]>
> 
> Yay!
> 
> Reviewed-by: Russell King (Oracle) <[email-masked]>

Hi Russell

I did wonder about making this a parameter for phylink mac up
callback, rather than having the driver look inside phydev. It is
something which can be done later.

	  Andrew